【数据结构-堆】力扣3066. 超过阈值的最少操作数 II

给你一个下标从 0 开始的整数数组 nums 和一个整数 k 。

一次操作中,你将执行:

选择 nums 中最小的两个整数 x 和 y 。

将 x 和 y 从 nums 中删除。

将 min(x, y) * 2 + max(x, y) 添加到数组中的任意位置。

注意,只有当 nums 至少包含两个元素时,你才可以执行以上操作。

你需要使数组中的所有元素都大于或等于 k ,请你返回需要的 最少 操作次数。

示例 1:

输入:nums = 2,11,10,1,3, k = 10

输出:2

解释:第一次操作中,我们删除元素 1 和 2 ,然后添加 1 * 2 + 2 到 nums 中,nums 变为 4, 11, 10, 3 。

第二次操作中,我们删除元素 3 和 4 ,然后添加 3 * 2 + 4 到 nums 中,nums 变为 10, 11, 10 。

此时,数组中的所有元素都大于等于 10 ,所以我们停止操作。

使数组中所有元素都大于等于 10 需要的最少操作次数为 2 。

示例 2:

输入:nums = 1,1,2,4,9, k = 20

输出:4

解释:第一次操作后,nums 变为 2, 4, 9, 3 。

第二次操作后,nums 变为 7, 4, 9 。

第三次操作后,nums 变为 15, 9 。

第四次操作后,nums 变为 33 。

此时,数组中的所有元素都大于等于 20 ,所以我们停止操作。

使数组中所有元素都大于等于 20 需要的最少操作次数为 4 。

最小堆

cpp 复制代码
class Solution {
public:
    int minOperations(vector<int>& nums, int k) {
        priority_queue<long long, vector<long long>, greater<long long>> q(nums.begin(), nums.end());
        int cnt = 0;
        while(q.top() < k){
            long long x = q.top();
            q.pop();
            long long y = q.top();
            q.pop();
            long long a = min(x,y) * 2 + max(x, y);
            q.push(a);

            cnt++;
        }
        return cnt;
    }
};

这道题我们要找最小的两个数,我们可以用优先队列,并且定义greater使其为最小堆,也就是升序排序。接下来就是进行模拟即可,直到q中的最小元素大于等于k为止。

相关推荐
在所不辞兄4 小时前
选择隐式方法求解刚性ODE
算法
码爸5 小时前
贪心算法介绍与示例
算法·贪心算法
-dzk-5 小时前
【多维动态规划】LC 64.最小路径和
算法·动态规划
垆边人似月.6 小时前
华为机试题 :字符串压缩
算法·华为
ggb喔6 小时前
52pojie 的图片工具:为什么无损转换后体积涨了 6 倍、照片方向还是歪的
图像处理·python·算法·计算机视觉·图形渲染·媒体
菜鸟~noob2336 小时前
【电子战】第25篇:自由空间、双射线与菲涅尔区【含matlab代码】
开发语言·算法·matlab
地平线开发者6 小时前
地平线征程6M YOLOv8s 部署
算法·自动驾驶
Run_Teenage6 小时前
算法:Manacher(马拉车)算法、中心扩展算法
算法
Tisfy7 小时前
LeetCode 0301.删除无效的括号:二进制枚举 / 回溯
算法·leetcode·字符串·题解·回溯·括号匹配·二进制枚举
Nil2087 小时前
leetcode 322零钱兑换
算法·leetcode·职场和发展